﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Security;
using System.Security.Permissions;
using System.Security.Policy;
using System.Reflection;

namespace TestApp
{
    class Program
    {
        static void Main(string[] args)
        {
            // 添加程序集凭据
            // 此处是为了装逼，才写以下几行
            // 其实你可以直接用 AppDomain.CurrentDomain.Evidence
            Evidence evd = new Evidence();
            Assembly currAss = Assembly.GetExecutingAssembly();
            Hash hsevd = new Hash(currAss);
            evd.AddAssemblyEvidence<Hash>(hsevd);

            // 准备相关信息
            AppDomainSetup setup = new AppDomainSetup();
            setup.ApplicationBase = AppDomain.CurrentDomain.SetupInformation.ApplicationBase;

            // 准备权限
            PermissionSet ps = new PermissionSet(PermissionState.None);
            // Execution 权限必须，不然连代码都不能执行了
            SecurityPermission secps = new SecurityPermission(SecurityPermissionFlag.Execution);
            ps.AddPermission(secps);
            string docPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            FileIOPermission fps = new FileIOPermission(FileIOPermissionAccess.AllAccess, docPath);
            ps.AddPermission(fps);

            // 创建新域
            AppDomain newAppdm = AppDomain.CreateDomain("good", evd, setup, ps);
            // 创建测试对象实例
            Demo d = (Demo)newAppdm.CreateInstanceAndUnwrap(currAss.FullName, $"{nameof(TestApp)}.{nameof(Demo)}");
            d.WriteFile();

            d = null;
            AppDomain.Unload(newAppdm);

            Console.Read();
        }
    }

    public class Demo : MarshalByRefObject
    {
        public void WriteFile()
        {
            string myDoc = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string filePath = Path.Combine(myDoc, Guid.NewGuid() + ".txt");
            using (FileStream fs = File.Open(filePath, FileMode.OpenOrCreate, FileAccess.Write, FileShare.Read))
            {
                byte[] data = Encoding.UTF8.GetBytes("卖假药啦。");
                fs.Write(data, 0, data.Length);
            }
            Console.WriteLine("文件写入成功。");
        }
    }
}
